﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

public partial class Admin_Item_Min_Price : System.Web.UI.Page
{
    SqlConnection conn = new SqlConnection((ConfigurationManager.ConnectionStrings["MegaConn"]).ToString());
    SqlTransaction insert_trans;

    protected void Page_Load(object sender, EventArgs e)
    {
        gvproducts.RowDataBound += new GridViewRowEventHandler(gvproducts_RowDataBound);
        if (!IsPostBack)
        {
            fillddl();
            tdproductlist.Visible = false;
            btnsave.Visible = false;
        }
        else
        {
            Azure.AZUREClass.bindgrid(gvproducts);          
        }
    }    
    void gvproducts_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        e.Row.Cells[0].Visible = false;
        e.Row.Cells[1].Visible = false;      

        if (e.Row.RowType == DataControlRowType.Header)
        {
            DataTable d1 = Azure.AZUREClass.getDataTable("select top 1 Currency_cd from Currency_Mst (nolock) where home_curr_flag ='Y'");
            if (d1.Rows.Count > 0)
            {
                if (d1.Rows[0][0].ToString() != "")
                {
                    e.Row.Cells[4].Text = "Min Amount in " + d1.Rows[0][0].ToString().Trim();
                    e.Row.Cells[5].Text = "Max Amount in " + d1.Rows[0][0].ToString().Trim();
                }
            }             
        }
        if (e.Row.RowType == DataControlRowType.DataRow)
        {         
            TextBox txtmingprice = new TextBox();
            txtmingprice.Width = 120;
            e.Row.Cells[4].Controls.Add(txtmingprice);
            if (e.Row.Cells[4].Text.Trim() != "&nbsp;" && e.Row.Cells[4].Text.Trim() != "")
                txtmingprice.Text = e.Row.Cells[4].Text.Replace("&nbsp;", "");

            TextBox txtmaxgprice = new TextBox();
            txtmaxgprice.Width = 120;
            e.Row.Cells[5].Controls.Add(txtmaxgprice);
            if (e.Row.Cells[5].Text.Trim() != "&nbsp;" && e.Row.Cells[5].Text.Trim() != "")
                txtmaxgprice.Text = e.Row.Cells[5].Text.Replace("&nbsp;", "");
        }
    }
    public void fillddl()
    {
        ddlcategory.Items.Clear();
        Azure.AZUREClass.BindDropDownList(ddlcategory, "select distinct Item_Category_ID,Main_Category_Desc from Item_Main_Category where Del_flag='N'", true);
    }
    public void gvcategorybind()
    {
        DataTable dtmain = new DataTable();
        if (ddlcategory.SelectedIndex > 0)
        {
            string query = "select  i.ItemID,u.UOM_ID,Item_Long_Name as 'Product',u1.UOM_Short_Desc as 'UOM',(select Min_Price from Item_Sales_Price where ItemID=i.ItemID and UOM_ID=U.UOM_ID) as 'Min.Price',(select Max_Price from Item_Sales_Price where ItemID=i.ItemID and UOM_ID=U.UOM_ID) as 'Max.Price'  from Item_Mst i inner join Item_UOM_Link u on u.ItemID=i.ItemID inner join UOM_mst u1 on u1.UOM_ID=u.UOM_ID  where u.UOM_Type_GCD=1001 and Item_Category_ID='" + ddlcategory.SelectedValue.Trim() + "'";
            dtmain = Azure.AZUREClass.getDataTable(query);
            if (dtmain.Rows.Count > 0)
            {
                gvproducts.DataSource = dtmain;
                gvproducts.DataBind();
                tdproductlist.Visible = true;
                btnsave.Visible = true;
            }
            else
            {
                gvproducts.DataSource = null;
                gvproducts.DataBind();
                tdproductlist.Visible = false;
                btnsave.Visible = false;
            }
        }
        
    }
    public void cleardata()
    {        
        ddlcategory.ClearSelection();
        gvproducts.DataSource = null;
        gvproducts.DataBind();
        tdproductlist.Visible = false;
        btnsave.Visible = false;
     }
    protected void btnsave_Click(object sender, EventArgs e)
    {
        bool flagcheck = true;
        if (ddlcategory.SelectedIndex == 0)
        {
            ScriptManager.RegisterStartupScript(this, this.GetType(), "alert", "alert('Please Select Category Name!');", true);           
            return;
        }
        for (int i = 0; i < gvproducts.Rows.Count; i++)
        {
            TextBox txtamount = (TextBox)gvproducts.Rows[i].Cells[4].Controls[0];
            if (txtamount.Text != "")
            {
                flagcheck = false;
                break;
            }
        }
        if (flagcheck == true)
        {
            ScriptManager.RegisterStartupScript(this, this.GetType(), "alert", "alert('Enter Amount');", true);
            return;
        }

        if (conn.State == ConnectionState.Closed) conn.Open();
        insert_trans = conn.BeginTransaction();
        SqlCommand cmd = new SqlCommand();
        cmd.Transaction = insert_trans;
        cmd.Connection = conn;
        cmd.CommandType = CommandType.StoredProcedure;
        try
        {

            Exception ex = new Exception();

            if (!saveproducts(cmd))
                throw ex;
            else
                cmd.Parameters.Clear();


            insert_trans.Commit();
            cleardata();
            ScriptManager.RegisterStartupScript(this, this.GetType(), "alert0", "alert('Saved Successfully...');", true);
        }
        catch (Exception ex)
        {
            insert_trans.Rollback();
        }
        finally
        {
            insert_trans.Dispose();
            conn.Close();
        }
    }
    private bool saveproducts(SqlCommand cmd)
    {
        try
        {            
            for (int i = 0; i < gvproducts.Rows.Count; i++)
            {
                TextBox txtMINamount = (TextBox)gvproducts.Rows[i].Cells[4].Controls[0];
                TextBox txtMAXamount = (TextBox)gvproducts.Rows[i].Cells[5].Controls[0];
                
                cmd.CommandText = "sp_Save_Item_Sales_Price";
                cmd.Parameters.AddWithValue("@ItemID", gvproducts.Rows[i].Cells[0].Text.Trim().Replace("&nbsp;", ""));
                cmd.Parameters.AddWithValue("@UOM_ID", gvproducts.Rows[i].Cells[1].Text.Trim().Replace("&nbsp;", ""));

                if (txtMINamount.Text.ToString().Replace("&nbsp;", "").Trim() != "")
                    cmd.Parameters.AddWithValue("@Min_Price", txtMINamount.Text.ToString().Replace("&nbsp;", "").Trim());
                else
                    cmd.Parameters.AddWithValue("@Min_Price", DBNull.Value);

                if (txtMAXamount.Text.ToString().Replace("&nbsp;", "").Trim() != "")
                    cmd.Parameters.AddWithValue("@Max_Price", txtMAXamount.Text.ToString().Replace("&nbsp;", "").Trim());
                else
                    cmd.Parameters.AddWithValue("@Max_Price", DBNull.Value);                  

                cmd.Parameters.AddWithValue("@CreatedBy", Session["LogeedUser"] + "");
                  
                cmd.ExecuteNonQuery();
                cmd.Parameters.Clear();
               
            }

            return true;
        }
        catch
        {
            return false;
        }
    }
   protected void ddlcategory_SelectedIndexChanged(object sender, EventArgs e)
    {
        if (ddlcategory.SelectedValue != "")
        {
            gvcategorybind();
        }
        else
            ScriptManager.RegisterStartupScript(this, this.GetType(), "alert", "alert('Sorry,Select Category');", true);
        
    }
}