using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Drawing;
using System.IO;
using System.Data.SqlClient;
using System.Net;

public partial class ucFileAttachments : System.Web.UI.UserControl
{

    #region Declaration
    DataTable dtAttachements = new DataTable();
    DataRow drAttachements;
    
    ClsGeneral objGen = new ClsGeneral();
    ExceptionClass Ec = new ExceptionClass();
    #endregion

    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            
            if (!IsPostBack)
            {
                clearAttachements();
                Session["FileNames"] = "0";
                SqlParameter[] FetchCodeDesc = new SqlParameter[2];
                FetchCodeDesc[0] = new SqlParameter("@Type", "CodeDesc");
                FetchCodeDesc[1] = new SqlParameter("@session_id", Session["SessionId"].ToString());
                DataSet dsAttachType = Azure.SqlHelper.ExecuteDataset(Azure.DBCon.ConnectionString, CommandType.StoredProcedure, "sp_Gen_Fetch_AttachementType", FetchCodeDesc);
                //DataSet dsAttachType = DataAccessHelper.DataAccess.ExecuteDataSet(DataAccessHelper.DataAccess.ConnectionString, "sp_Gen_Fetch_AttachementType", CommandType.StoredProcedure, FetchCodeDesc);
                for (int r = 0; r < dsAttachType.Tables[0].Rows.Count; r++)
                {
                    ddlistAttachType.Items.Add(Convert.ToString(dsAttachType.Tables[0].Rows[r][1]));
                    ddlistAttachType.Items[r].Value = dsAttachType.Tables[0].Rows[r][0].ToString();
                }
            }

            btnAttachement.Attributes.Add("onmouseover", "this.src = '../Images/add_over.gif';");
            btnAttachement.Attributes.Add("onmouseout", "this.src = '../Images/add_normal.gif';");

            btnDelete.Attributes.Add("onmouseover", "this.src = '../Images/delete_over.gif';");
            btnDelete.Attributes.Add("onmouseout", "this.src = '../Images/delete_normal.gif';");

            btnClose.Attributes.Add("onmouseover", "this.src = '../Images/Close_over.gif';");
            btnClose.Attributes.Add("onmouseout", "this.src = '../Images/Close_normal.gif';");

            lblFileName.Attributes.Add("onFocus", "document.getElementById('" + btnAttachement.ClientID + "').focus(); ");

            
                if (Convert.ToString(Session["btnState"]) == "btnEdit")
                {
                    fileAttachment.Enabled = true;
                    ddlistAttachType.Enabled = true;
                    btnAttachement.Visible = true;
                    btnDelete.Visible = true;
                    gvAttachements.Enabled = true;
                }
                else if (Convert.ToString(Session["btnState"]) == "btnAdd")
                {
                    fileAttachment.Enabled = true;
                    ddlistAttachType.Enabled = true;
                    btnAttachement.Visible = true;
                    btnDelete.Visible = true;
                    gvAttachements.Enabled = true;
                    //clearAttachements();
                }
                else
                {
                    fileAttachment.Enabled = false;
                    ddlistAttachType.Enabled = false;
                    btnAttachement.Visible = false;
                    btnDelete.Visible = false;
                    gvAttachements.Enabled = false;
                }
            
        }
        catch (Exception ex)
        {
            lblErrorMsg.Text = Convert.ToString(Ec.WriteException(ex));
            lblErrorMsg.Visible = true;
        }
        finally
        {
        }
    }

    protected void clearAttachements()
    {
        try
        {
            dtAttachements = new DataTable();
            dtAttachements.Columns.Add("SNo");
            dtAttachements.Columns.Add("Attachment Code");
            dtAttachements.Columns.Add("Attachment Type");
            dtAttachements.Columns.Add("File Name");
            dtAttachements.Columns.Add("File Location");
            dtAttachements.Columns.Add("Stored Location");
            dtAttachements.Columns.Add("Edit");
            dtAttachements.Columns.Add("StoredFileName");
            dtAttachements.AcceptChanges();
            objGen.FillEmptyRows(ref dtAttachements);
            gvAttachements.DataSource = dtAttachements;
            gvAttachements.DataBind();
            Session["dtAttachements"] = dtAttachements;
        }
        catch (System.Data.SqlClient.SqlException ex)
        {
            lblErrorMsg.Text = Convert.ToString(Ec.WriteSQLException(ex));
            lblErrorMsg.Visible = true;
        }
        catch (System.Exception ex)
        {
            lblErrorMsg.Text = Convert.ToString(Ec.WriteException(ex));
            lblErrorMsg.Visible = true;
        }
        finally
        {
        }
    }
    

    protected void gvAttachements_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        try
        {
            //1("SNo")  //2("Attachment Code")
            //3("Attachment Type")  //4("File Name")
            //5("File Location")    //6("Stored Location")
            //7("Edit") //8("StoredFileName")
            e.Row.Cells[0].Width = new Unit("5%");
            e.Row.Cells[1].Width = new Unit("5%");
            //e.Row.Cells[2].Width = new Unit("10%");
            e.Row.Cells[3].Width = new Unit("20%");
            e.Row.Cells[4].Width = new Unit("25%");
            e.Row.Cells[5].Width = new Unit("45%");
            e.Row.Cells[2].Attributes.Add("style", "display:none");
            e.Row.Cells[6].Attributes.Add("style", "display:none");
            e.Row.Cells[7].Attributes.Add("style", "display:none");
            e.Row.Cells[8].Attributes.Add("style", "display:none");
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                if (e.Row.RowIndex >= 0)
                {
                    e.Row.Attributes["style"] = "cursor:pointer;";
                    e.Row.Attributes.Add("OnClick", "RowActions(" + (e.Row.RowIndex + 1) + ",'" + Convert.ToString(gvAttachements.ClientID).Trim() + "')");
                }
                else
                {
                    e.Row.BackColor = Color.Silver;
                }

                CheckBox chk = new CheckBox();
                chk = (CheckBox)e.Row.Cells[0].FindControl("cbSelect");
                chk.Attributes.Add("onclick", "return UnSelectAll(" + (Convert.ToInt32(e.Row.RowIndex) + 1) + ");");
            }

            for (int r = 0; r < gvAttachements.Rows.Count; r++)
            {
                CheckBox cbSelectRow = (CheckBox)gvAttachements.Rows[r].Cells[0].FindControl("cbSelect");
                if(Convert.ToString(gvAttachements.Rows[r].Cells[2].Text) != "&nbsp;")
                {
                    gvAttachements.Rows[r].Cells[1].Text = Convert.ToString(r+1);
                    cbSelectRow.Enabled = true;
                } 
                else
                cbSelectRow.Enabled = false;
            }

        }
        catch (System.Data.SqlClient.SqlException ex)
        {
            lblErrorMsg.Text = Convert.ToString(Ec.WriteSQLException(ex));

            lblErrorMsg.Visible = true;
        }
        catch (System.Exception ex)
        {
            lblErrorMsg.Text = Convert.ToString(Ec.WriteException(ex));

            lblErrorMsg.Visible = true;
        }
        finally
        {

        }
    }
    public void EditDeleteFileAttachments(string TransactionKey,string state)
    {
        try
        {

            string SystemIP = Convert.ToString(Request.UserHostAddress);
            string strDate = "";

            dtAttachements = (DataTable)Session["dtAttachements"];

            gvAttachements.DataSource = dtAttachements;
            gvAttachements.DataBind();
            for (int r = 0; r < gvAttachements.Rows.Count; r++)
            {
                if (Convert.ToString(gvAttachements.Rows[r].Cells[2].Text) != "&nbsp;")
                {
                    //1 ("SNo") //2("Attachment Code")
                    //3 ("Attachment Type") //4 ("File Name")
                    //5("File Location")    //6("Stored Location")
                    strDate = DateTime.Now.ToString("dd-MM-yyyy HH-mm-ss");
                    string StoredFileName = TransactionKey + "_" + strDate + "_" + Convert.ToString(gvAttachements.Rows[r].Cells[4].Text);

                    //string StoredFileName = TransactionKey + "_" + Convert.ToString(gvAttachements.Rows[r].Cells[2].Text);
                    string filename = Convert.ToString(Server.MapPath("../File_Attachments/" + StoredFileName));
                    File.Copy(Convert.ToString(gvAttachements.Rows[r].Cells[5].Text).Trim(), filename);
                    SqlParameter[] InsertFile = new SqlParameter[11];
                    InsertFile[0] = new SqlParameter("@CompanyCode", Convert.ToString(Session["sessioncompanycode"]));
                    InsertFile[1] = new SqlParameter("@LocationCode", Convert.ToString(Session["sessionLocationcode"]));
                    InsertFile[2] = new SqlParameter("@AttachTypeGcd", Convert.ToInt64(gvAttachements.Rows[r].Cells[2].Text));

                    InsertFile[3] = new SqlParameter("@OriginalFileName", Convert.ToString(gvAttachements.Rows[r].Cells[4].Text));
                    InsertFile[4] = new SqlParameter("@StoredFileName", StoredFileName);
                    InsertFile[5] = new SqlParameter("@TransactionKey", TransactionKey);
                    InsertFile[6] = new SqlParameter("@AttachFileLocation", Convert.ToString(gvAttachements.Rows[r].Cells[5].Text));
                    InsertFile[7] = new SqlParameter("@SystemIP", SystemIP);
                    InsertFile[8] = new SqlParameter("@SessionId", Convert.ToString(Session["SessionId"]));
                    InsertFile[9] = new SqlParameter("@CreatedBy", Convert.ToString(Session["LogeedUser"]));
                    InsertFile[10] = new SqlParameter("@State", state);

                    Azure.SqlHelper.ExecuteNonQuery(Azure.DBCon.ConnectionString, CommandType.StoredProcedure, "sp_Gen_EditdeleteInsert_File_Attachment", InsertFile);
                    //DataAccessHelper.DataAccess.ExecuteNonQuery(DataAccessHelper.DataAccess.ConnectionString, "sp_Gen_EditdeleteInsert_File_Attachment", CommandType.StoredProcedure, InsertFile);

                    StoredFileName = Convert.ToString(gvAttachements.Rows[r].Cells[4].Text);
                    filename = Convert.ToString(Server.MapPath("../File_Attachments/" + StoredFileName));
                    File.Delete(filename);
                    state = "A";
                }
            }

        }
        catch (System.Data.SqlClient.SqlException ex)
        {
            lblErrorMsg.Text = Convert.ToString(Ec.WriteSQLException(ex));

            lblErrorMsg.Visible = true;
        }
        catch (System.Exception ex)
        {
            lblErrorMsg.Text = Convert.ToString(Ec.WriteException(ex));

            lblErrorMsg.Visible = true;
        }
        finally
        {

        }

    }

    public void FileAttachments(string TransactionKey)
    {
        try
        {
            
          string SystemIP = Convert.ToString(Request.UserHostAddress);
          string strDate = "";
          
          dtAttachements = (DataTable) Session["dtAttachements"];

          gvAttachements.DataSource = dtAttachements;
          gvAttachements.DataBind();
            for (int r = 0; r < gvAttachements.Rows.Count; r++)
            {
                if (Convert.ToString(gvAttachements.Rows[r].Cells[2].Text) != "&nbsp;")
                {
                    //1 ("SNo") //2("Attachment Code")
                    //3 ("Attachment Type") //4 ("File Name")
                    //5("File Location")    //6("Stored Location")
                    strDate = DateTime.Now.ToString("dd-MM-yyyy HH-mm-ss");
                    string StoredFileName = TransactionKey + "_" + strDate + "_" + Convert.ToString(gvAttachements.Rows[r].Cells[4].Text);

                    //string StoredFileName = TransactionKey + "_" + Convert.ToString(gvAttachements.Rows[r].Cells[2].Text);
                    string filename = Convert.ToString(Server.MapPath("../File_Attachments/" + StoredFileName));
                    File.Copy(Convert.ToString(gvAttachements.Rows[r].Cells[5].Text).Trim(), filename);
                    SqlParameter[] InsertFile = new SqlParameter[10];
                    InsertFile[0] = new SqlParameter("@CompanyCode", Convert.ToString(Session["sessioncompanycode"]));
                    InsertFile[1] = new SqlParameter("@LocationCode", Convert.ToString(Session["sessionLocationcode"]));
                    InsertFile[2] = new SqlParameter("@AttachTypeGcd", Convert.ToInt64(gvAttachements.Rows[r].Cells[2].Text));
                    
                    InsertFile[3] = new SqlParameter("@OriginalFileName", Convert.ToString(gvAttachements.Rows[r].Cells[4].Text));
                    InsertFile[4] = new SqlParameter("@StoredFileName", StoredFileName);
                    InsertFile[5] = new SqlParameter("@TransactionKey", TransactionKey);
                    InsertFile[6] = new SqlParameter("@AttachFileLocation", Convert.ToString(gvAttachements.Rows[r].Cells[5].Text));
                    InsertFile[7] = new SqlParameter("@SystemIP", SystemIP);
                    InsertFile[8] = new SqlParameter("@SessionId", Convert.ToString(Session["SessionId"]));
                    InsertFile[9] = new SqlParameter("@CreatedBy", Convert.ToString(Session["LogeedUser"]));

                    Azure.SqlHelper.ExecuteNonQuery(Azure.DBCon.ConnectionString, CommandType.StoredProcedure, "sp_Gen_Insert_File_Attachment", InsertFile);
                    //DataAccessHelper.DataAccess.ExecuteNonQuery(DataAccessHelper.DataAccess.ConnectionString, "sp_Gen_Insert_File_Attachment", CommandType.StoredProcedure, InsertFile);

                    StoredFileName = Convert.ToString(gvAttachements.Rows[r].Cells[4].Text);
                    filename = Convert.ToString(Server.MapPath("../File_Attachments/" + StoredFileName));
                    File.Delete(filename);

                }
            }

        }
        catch (System.Data.SqlClient.SqlException ex)
        {
            lblErrorMsg.Text = Convert.ToString(Ec.WriteSQLException(ex));

            lblErrorMsg.Visible = true;
        }
        catch (System.Exception ex)
        {
            lblErrorMsg.Text = Convert.ToString(Ec.WriteException(ex));

            lblErrorMsg.Visible = true;
        }
        finally
        {

        }

    }

    public void FileAttachments()
    {
        try
        {

            string SystemIP = Convert.ToString(Request.UserHostAddress);
            string strDate;
            for (int r = 0; r < gvAttachements.Rows.Count; r++)
            {
                if (Convert.ToString(gvAttachements.Rows[r].Cells[2].Text) != "&nbsp;")
                {
                    strDate = DateTime.Now.ToString("dd-MM-yyyy HH-mm-ss");
                    string StoredFileName = strDate + "_" + Convert.ToString(gvAttachements.Rows[r].Cells[4].Text);

                    string filename = Convert.ToString(Server.MapPath("../File_Attachments/" + StoredFileName));
                    File.Copy(Convert.ToString(gvAttachements.Rows[r].Cells[5].Text).Trim(), filename);
                    SqlParameter[] InsertFile = new SqlParameter[10];
                    InsertFile[0] = new SqlParameter("@CompanyCode", Convert.ToString(Session["sessioncompanycode"]));
                    InsertFile[1] = new SqlParameter("@LocationCode", Convert.ToString(Session["sessionLocationcode"]));
                    InsertFile[2] = new SqlParameter("@AttachTypeGcd", Convert.ToInt64(gvAttachements.Rows[r].Cells[2].Text));
                    InsertFile[3] = new SqlParameter("@OriginalFileName", Convert.ToString(gvAttachements.Rows[r].Cells[4].Text));
                    InsertFile[4] = new SqlParameter("@StoredFileName", StoredFileName);
                    InsertFile[5] = new SqlParameter("@TransactionKey", null);
                    InsertFile[6] = new SqlParameter("@AttachFileLocation", Convert.ToString(gvAttachements.Rows[r].Cells[5].Text));
                    InsertFile[7] = new SqlParameter("@SystemIP", SystemIP);
                    InsertFile[8] = new SqlParameter("@SessionId", Convert.ToString(Session["SessionId"]));
                    InsertFile[9] = new SqlParameter("@CreatedBy", Convert.ToString(Session["LogeedUser"]));

                    Azure.SqlHelper.ExecuteNonQuery(Azure.DBCon.ConnectionString, CommandType.StoredProcedure, "sp_Gen_Insert_File_Attachment", InsertFile);
                    //DataAccessHelper.DataAccess.ExecuteNonQuery(DataAccessHelper.DataAccess.ConnectionString, "sp_Gen_Insert_File_Attachment", CommandType.StoredProcedure, InsertFile);
                }
            }

        }
        catch (System.Data.SqlClient.SqlException ex)
        {
            lblErrorMsg.Text = Convert.ToString(Ec.WriteSQLException(ex));

            lblErrorMsg.Visible = true;
        }
        catch (System.Exception ex)
        {
            lblErrorMsg.Text = Convert.ToString(Ec.WriteException(ex));

            lblErrorMsg.Visible = true;
        }
        finally
        {

        }

    }

    public void RemoveAttachments(string TransactionKey)
    {
        try
        {
            dtAttachements = (DataTable)Session["dtAttachements"];
            for (int r = 0; r < gvAttachements.Rows.Count; r++)
            {
                if (Convert.ToString(gvAttachements.Rows[r].Cells[2].Text) != "&nbsp;")
                {
                    string StoredFileName = TransactionKey + "_" + Convert.ToString(gvAttachements.Rows[r].Cells[2].Text);

                    string filename = Convert.ToString(Server.MapPath("../File_Attachments/" + StoredFileName));

                    File.Delete(filename);
                }
            }
           
        }
        catch (System.Exception ex)
        {
            lblErrorMsg.Text = Convert.ToString(Ec.WriteException(ex));

            lblErrorMsg.Visible = true;
        }
        finally
        {

        }

    }

    public void RemoveAttachments()
    {
        try
        {
            dtAttachements = (DataTable)Session["dtAttachements"];

            for (int r = 0; r < gvAttachements.Rows.Count; r++)
            {
                if (Convert.ToString(gvAttachements.Rows[r].Cells[2].Text) != "&nbsp;")
                {
                    string StoredFileName = Convert.ToString(gvAttachements.Rows[r].Cells[2].Text);

                    string filename = Convert.ToString(Server.MapPath("../File_Attachments/" + StoredFileName));

                    File.Delete(filename);
                }
            }

        }
        catch (System.Exception ex)
        {
            lblErrorMsg.Text = Convert.ToString(Ec.WriteException(ex));

            lblErrorMsg.Visible = true;
        }
        finally
        {

        }

    }

    public void NewFileAttachments()
    {
        dtAttachements = new DataTable();
        clearAttachements();
    }

    public void EditFileAttachments(string TransactionKey)
    {
        try
        {

            string SystemIP = Convert.ToString(Request.UserHostAddress);
            string strDate = "";

            dtAttachements = (DataTable)Session["dtAttachements"];
            dtAttachements.AcceptChanges();
            gvAttachements.DataSource = dtAttachements;
            gvAttachements.DataBind();
            for (int r = 0; r < gvAttachements.Rows.Count; r++)
            {
                if (Convert.ToString(gvAttachements.Rows[r].Cells[7].Text) == "Edit")
                {
                    //1 ("SNo") //2("Attachment Code")
                    //3 ("Attachment Type") //4 ("File Name")
                    //5("File Location")    //6("Stored Location")
                    strDate = DateTime.Now.ToString("dd-MM-yyyy HH-mm-ss");

                    string StoredFileName = TransactionKey + "_" + strDate + "_" + Convert.ToString(gvAttachements.Rows[r].Cells[4].Text);

                    //string StoredFileName = TransactionKey + "_" + Convert.ToString(gvAttachements.Rows[r].Cells[2].Text);
                    string filename = Convert.ToString(Server.MapPath("../File_Attachments/" + StoredFileName));
                    File.Copy(Convert.ToString(gvAttachements.Rows[r].Cells[5].Text).Trim(), filename);
                    SqlParameter[] InsertFile = new SqlParameter[10];
                    InsertFile[0] = new SqlParameter("@CompanyCode", Convert.ToString(Session["sessioncompanycode"]));
                    InsertFile[1] = new SqlParameter("@LocationCode", Convert.ToString(Session["sessionLocationcode"]));
                    InsertFile[2] = new SqlParameter("@AttachTypeGcd", Convert.ToInt64(gvAttachements.Rows[r].Cells[2].Text));

                    InsertFile[3] = new SqlParameter("@OriginalFileName", Convert.ToString(gvAttachements.Rows[r].Cells[4].Text));
                    InsertFile[4] = new SqlParameter("@StoredFileName", StoredFileName);
                    InsertFile[5] = new SqlParameter("@TransactionKey", TransactionKey);
                    InsertFile[6] = new SqlParameter("@AttachFileLocation", Convert.ToString(gvAttachements.Rows[r].Cells[5].Text));
                    InsertFile[7] = new SqlParameter("@SystemIP", SystemIP);
                    InsertFile[8] = new SqlParameter("@SessionId", Convert.ToString(Session["SessionId"]));
                    InsertFile[9] = new SqlParameter("@CreatedBy", Convert.ToString(Session["LogeedUser"]));

                    Azure.SqlHelper.ExecuteNonQuery(Azure.DBCon.ConnectionString, CommandType.StoredProcedure, "sp_Gen_Insert_File_Attachment", InsertFile);
                    //DataAccessHelper.DataAccess.ExecuteNonQuery(DataAccessHelper.DataAccess.ConnectionString, "sp_Gen_Insert_File_Attachment", CommandType.StoredProcedure, InsertFile);
                    StoredFileName = Convert.ToString(gvAttachements.Rows[r].Cells[4].Text);
                    filename = Convert.ToString(Server.MapPath("../File_Attachments/" + StoredFileName));
                    File.Delete(filename);

                }
            }

        }
        catch (System.Data.SqlClient.SqlException ex)
        {
            lblErrorMsg.Text = Convert.ToString(Ec.WriteSQLException(ex));

            lblErrorMsg.Visible = true;
        }
        catch (System.Exception ex)
        {
            lblErrorMsg.Text = Convert.ToString(Ec.WriteException(ex));

            lblErrorMsg.Visible = true;
        }
        finally
        {

        }

    }
    public void DeleteAttachments(string TransactionKey)
    {
        try
        {

            string SystemIP = Convert.ToString(Request.UserHostAddress);
            string strDate = "";
            dtAttachements = (DataTable)Session["dtAttachements"];
            dtAttachements.AcceptChanges();
            gvAttachements.DataSource = dtAttachements;
            gvAttachements.DataBind();

            //1 ("SNo") //2("Attachment Code")
            //3 ("Attachment Type") //4 ("File Name")
            //5("File Location")    //6("Stored Location")
            for (int r = 0; r < gvAttachements.Rows.Count; r++)
            {
                if (Convert.ToString(gvAttachements.Rows[r].Cells[5].Text) != "&nbsp;")
                Session["FileNames"] += "," + Convert.ToString(gvAttachements.Rows[r].Cells[4].Text);
            }
            SqlParameter[] DeleteFile = new SqlParameter[4];
            DeleteFile[0] = new SqlParameter("@TransactionKey", TransactionKey);
            DeleteFile[1] = new SqlParameter("@FileNames", Convert.ToString(Session["FileNames"]));
            DeleteFile[2] = new SqlParameter("@SystemIP", SystemIP);
            DeleteFile[3] = new SqlParameter("@ModifiedBy", Convert.ToString(Session["LogeedUser"]));

            Azure.SqlHelper.ExecuteNonQuery(Azure.DBCon.ConnectionString, CommandType.StoredProcedure, "sp_Gen_FileAttachments_Delete", DeleteFile);Azure.SqlHelper.ExecuteNonQuery(Azure.DBCon.ConnectionString, CommandType.StoredProcedure, "sp_Gen_FileAttachments_Delete", DeleteFile);
         //   DataAccessHelper.DataAccess.ExecuteNonQuery(DataAccessHelper.DataAccess.ConnectionString, "sp_Gen_FileAttachments_Delete", CommandType.StoredProcedure, DeleteFile);
        }
        catch (System.Data.SqlClient.SqlException ex)
        {
            lblErrorMsg.Text = Convert.ToString(Ec.WriteSQLException(ex));

            lblErrorMsg.Visible = true;
        }
        catch (System.Exception ex)
        {
            lblErrorMsg.Text = Convert.ToString(Ec.WriteException(ex));

            lblErrorMsg.Visible = true;
        }
        finally
        {

        }

    }
    public void LoadFileAttachments(string TransactionKey)
    {
        try
        {
            if (Convert.ToString(Session["btnState"]) != "btnAdd")
            {
               
                    //1 ("SNo") //2("Attachment Code")  //3 ("Attachment Type") //4 ("File Name")
                    //5("File Location")    //6("Stored Location")
                    SqlParameter[] FetchFileAttachments = new SqlParameter[1];
                    FetchFileAttachments[0] = new SqlParameter("@TransactionKey", TransactionKey.Trim());

                    DataSet dsFileAttachments = Azure.SqlHelper.ExecuteDataset(Azure.DBCon.ConnectionString, CommandType.StoredProcedure, "sp_Gen_Fetch_FileAttachment_Details", FetchFileAttachments);
                    //DataSet dsFileAttachments = DataAccessHelper.DataAccess.ExecuteDataSet(DataAccessHelper.DataAccess.ConnectionString, "sp_Gen_Fetch_FileAttachment_Details", CommandType.StoredProcedure, FetchFileAttachments);
                    //clearAttachements();
                    dtAttachements = (DataTable)Session["dtAttachements"];
                    objGen.RemoveEmptyRows(ref dtAttachements);
                    for (int r = 0; r < dsFileAttachments.Tables[0].Rows.Count; r++)
                    {
                        drAttachements = dtAttachements.NewRow();
                        drAttachements["Attachment Code"] = Convert.ToString(dsFileAttachments.Tables[0].Rows[r][0]);
                        drAttachements["Attachment Type"] = Convert.ToString(dsFileAttachments.Tables[0].Rows[r][1]);
                        drAttachements["File Name"] = Convert.ToString(dsFileAttachments.Tables[0].Rows[r][2]);
                        drAttachements["File Location"] = Convert.ToString(dsFileAttachments.Tables[0].Rows[r][3]);
                        drAttachements["StoredFileName"] = "../File_Attachments/" + Convert.ToString(dsFileAttachments.Tables[0].Rows[r][4]);
                        dtAttachements.Rows.Add(drAttachements);
                    }
                    dtAttachements.AcceptChanges();
                    objGen.FillEmptyRows(ref dtAttachements);
                    gvAttachements.DataSource = dtAttachements;
                    gvAttachements.DataBind();
                    Session["dtAttachements"] = dtAttachements;
                
            }
        }
        catch (System.Exception ex)
        {
            lblErrorMsg.Text = Convert.ToString(Ec.WriteException(ex));
            lblErrorMsg.Visible = true;
        }
        finally
        {
        }
    }
    public void LoadFileAttachments_Masters(string TransactionKey,string Sessioin_id)
    {
        try
        {
            if (Convert.ToString(Session["btnState"]) != "btnAdd")
            {

                //1 ("SNo") //2("Attachment Code")  //3 ("Attachment Type") //4 ("File Name")
                //5("File Location")    //6("Stored Location")
                SqlParameter[] FetchFileAttachments = new SqlParameter[2];
                FetchFileAttachments[0] = new SqlParameter("@TransactionKey", TransactionKey.Trim());
                FetchFileAttachments[1] = new SqlParameter("@Session_id", Sessioin_id.Trim());

                DataSet dsFileAttachments = Azure.SqlHelper.ExecuteDataset(Azure.DBCon.ConnectionString, CommandType.StoredProcedure, "sp_Gen_Fetch_FileAttachment_Details_Masters", FetchFileAttachments);
                //DataSet dsFileAttachments = DataAccessHelper.DataAccess.ExecuteDataSet(DataAccessHelper.DataAccess.ConnectionString, "sp_Gen_Fetch_FileAttachment_Details_Masters", CommandType.StoredProcedure, FetchFileAttachments);
               
                clearAttachements();
                objGen.RemoveEmptyRows(ref dtAttachements);
                for (int r = 0; r < dsFileAttachments.Tables[0].Rows.Count; r++)
                {
                    drAttachements = dtAttachements.NewRow();
                    drAttachements["Attachment Code"] = Convert.ToString(dsFileAttachments.Tables[0].Rows[r][0]);
                    drAttachements["Attachment Type"] = Convert.ToString(dsFileAttachments.Tables[0].Rows[r][1]);
                    drAttachements["File Name"] = Convert.ToString(dsFileAttachments.Tables[0].Rows[r][2]);
                    drAttachements["File Location"] = Convert.ToString(dsFileAttachments.Tables[0].Rows[r][3]);
                    drAttachements["StoredFileName"] = "../File_Attachments/" + Convert.ToString(dsFileAttachments.Tables[0].Rows[r][4]);
                    dtAttachements.Rows.Add(drAttachements);
                }
                dtAttachements.AcceptChanges();
                objGen.FillEmptyRows(ref dtAttachements);
                gvAttachements.DataSource = dtAttachements;
                gvAttachements.DataBind();
            }
        }
        catch (System.Exception ex)
        {
            lblErrorMsg.Text = Convert.ToString(Ec.WriteException(ex));
            lblErrorMsg.Visible = true;
        }
        finally
        {
        }
    }
    protected void cbSelect_CheckedChanged(object sender, EventArgs e)
    {
        try
        {
            int rowindex = Convert.ToInt16(hdnRowIndex.Value) - 1;
        }

        catch (System.Data.SqlClient.SqlException ex)
        {
            lblErrorMsg.Text = Convert.ToString(Ec.WriteSQLException(ex));

            lblErrorMsg.Visible = true;
        }
        catch (System.Exception ex)
        {
            lblErrorMsg.Text = Convert.ToString(Ec.WriteException(ex));

            lblErrorMsg.Visible = true;
        }
        finally
        {

        }
    }

    //protected void btnAttached_Click(object sender, EventArgs e)
    //{
    //    try
    //    {
    //        for (int row = 0; row < dtAttachements.Rows.Count; row++)
    //        {
    //            if (Convert.ToString(dtAttachements.Rows[row][1]) != "")
    //            {
    //                string filename = Convert.ToString(Server.MapPath("../Distribution/Transaction_Attachments/" + Convert.ToString(dtAttachements.Rows[row][1])));
    //                File.Copy(Convert.ToString(dtAttachements.Rows[row][2]), filename);
    //                dtAttachements.Rows[row][3] = "T"; 
    //            }
    //        }
    //        Page.ClientScript.RegisterStartupScript(typeof(string), "alertmsg", "alert('Files has been attached successfully!');", true);
    //    }
    //    catch (System.Data.SqlClient.SqlException ex)
    //    {
    //        lblErrorMsg.Text = Convert.ToString(Ec.WriteSQLException(ex));

    //        lblErrorMsg.Visible = true;
    //    }
    //    catch (System.Exception ex)
    //    {
    //        lblErrorMsg.Text = Convert.ToString(Ec.WriteException(ex));

    //        lblErrorMsg.Visible = true;
    //    }
    //    finally
    //    {

    //    }
    //}

    protected void btnDelete_Click(object sender, EventArgs e)
    {
        try
        {
            for (int r = 0; r < gvAttachements.Rows.Count; r++)
            {
                if (Convert.ToString(gvAttachements.Rows[r].Cells[2]) != "&nbsp;")
                {
                    string StoredFileName = Convert.ToString(gvAttachements.Rows[r].Cells[4].Text);
                    string filename = Convert.ToString(Server.MapPath("../File_Attachments/" + StoredFileName));
                    File.Delete(filename);
                    CheckBox cbSelectRow = (CheckBox)gvAttachements.Rows[r].Cells[0].FindControl("cbSelect");
                    if (cbSelectRow.Checked == true)
                    {
                        dtAttachements = (DataTable)Session["dtAttachements"];
                        dtAttachements.Rows[r].Delete();
                    }
                }
            }
            dtAttachements.AcceptChanges();
            objGen.FillEmptyRows(ref dtAttachements);
            gvAttachements.DataSource = dtAttachements;
            gvAttachements.DataBind();
            Session["dtAttachements"] = dtAttachements;
            this.Visible = true;
        }
        catch (System.Data.SqlClient.SqlException ex)
        {
            lblErrorMsg.Text = Convert.ToString(Ec.WriteSQLException(ex));

            lblErrorMsg.Visible = true;
        }
        catch (System.Exception ex)
        {
            lblErrorMsg.Text = Convert.ToString(Ec.WriteException(ex));

            lblErrorMsg.Visible = true;
        }
        finally
        {

        }
    }

    protected void btnAttachement_Click(object sender, EventArgs e)
    {
        try
        {
            string StoredFileName = Convert.ToString(fileAttachment.FileName);
            string filename = Convert.ToString(Server.MapPath("../File_Attachments/" + StoredFileName));
            //long FileMaxSize = 10485760;
            //int AttachFileSize = fileAttachment.PostedFile.ContentLength;
            //if (AttachFileSize > FileMaxSize)
            //{
            //    Page.ClientScript.RegisterStartupScript(typeof(string), "altmsg", "alert('User should not attach more than 10 MB');", true);
            //    return;
            //}
            
            //File.Copy(Convert.ToString(fileAttachment.PostedFile.FileName), filename);
            SqlParameter[] FetchCode = new SqlParameter[2];

            FetchCode[0] = new SqlParameter("@Type", "Code");
            FetchCode[1] = new SqlParameter("@CodeDesc", Convert.ToString(ddlistAttachType.SelectedItem.Text));

            DataSet dsAttachTypeCode = Azure.SqlHelper.ExecuteDataset(Azure.DBCon.ConnectionString, CommandType.StoredProcedure, "sp_Gen_Fetch_AttachementType", FetchCode);
            //DataSet dsAttachTypeCode = DataAccessHelper.DataAccess.ExecuteDataSet(DataAccessHelper.DataAccess.ConnectionString, "sp_Gen_Fetch_AttachementType", CommandType.StoredProcedure, FetchCode);

            dtAttachements = (DataTable)Session["dtAttachements"];
            objGen.RemoveEmptyRows(ref dtAttachements);
            drAttachements = dtAttachements.NewRow();
            //drAttachements[1] = Convert.ToString(dsAttachTypeCode.Tables[0].Rows[0][0]);
            drAttachements[1] = Convert.ToString(ddlistAttachType.SelectedValue);
            drAttachements[2] = Convert.ToString(ddlistAttachType.SelectedItem.Text);
            drAttachements[3] = Convert.ToString(fileAttachment.FileName);
            drAttachements[4] = Convert.ToString(fileAttachment.PostedFile.FileName);
            drAttachements[5] = "../File_Attachments/" + StoredFileName;
            if (Session["btnState"] == null || Convert.ToString(Session["btnState"]) == "btnEdit")
                drAttachements[6] = "Edit";
            drAttachements[7] = "../File_Attachments/" + StoredFileName;
            dtAttachements.Rows.Add(drAttachements);
            dtAttachements.AcceptChanges();
            objGen.FillEmptyRows(ref dtAttachements);
            gvAttachements.DataSource = dtAttachements;
            gvAttachements.DataBind();
            Session["dtAttachements"] = dtAttachements;
            this.Visible = true;
        }
        catch (System.Data.SqlClient.SqlException ex)
        {
            lblErrorMsg.Text = Convert.ToString(Ec.WriteSQLException(ex));

            lblErrorMsg.Visible = true;
        }
        //catch (System.Exception ex)
        //{
        //    lblErrorMsg.Text = Convert.ToString(Ec.WriteException(ex));

        //    lblErrorMsg.Visible = true;
        //}
        finally
        {

        }
    }



 
}
